#!/usr/bin/env python

# Copyright (C) 2004  Vasco Alexandre da Silva Costa
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import httplib, urllib, urllib2, pickle, os, sys
from optparse import OptionParser

usage = "usage: %prog [options] PAGE..."
parser = OptionParser(usage = usage)
parser.add_option("-d", "--debug",
		  action = "store_true", default = False,
                  help = "debug output")
parser.add_option("-m", "--message",
		  default = "update",
                  help = "log message", metavar = "STRING")

(options, args) = parser.parse_args()
if len(args) < 1:
	parser.error("incorrect number of arguments")

# Read the cookies from the jar.
try:
	jar = pickle.load(file(os.path.expanduser('~/.wikicookiejar')))
except:
	print "You need to login first."
	sys.exit(1)

params = {
	'wpReason': options.message,
	'wpConfirm': 1,
	'wpConfirmB': 'Confirm'
}

params = urllib.urlencode(params)

for arg in args:
	url = jar[0] + '/index.php?title=' + urllib.quote(arg) + '&action=delete'
	req = urllib2.Request(url)

	# HTTP POST arguments.
	req.add_data(params)

	# HTTP POST cookies.
	for [k, v] in jar[1:len(jar)]:
			req.add_header("Cookie", k + '=' + v)

	# Do the POST.
	res = urllib2.urlopen(req)

	# Print response to stdout.
	if options.debug:
		print res.read()

