#!/usr/bin/env python

# Copyright (C) 2004  Vasco Alexandre da Silva Costa
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import httplib, urllib, urllib2, pickle, os, re, sys
from optparse import OptionParser

usage = "usage: %prog [options] PAGE TEXT-FILE"
parser = OptionParser(usage = usage)
parser.add_option("-d", "--debug",
		  action = "store_true", default = False,
                  help = "debug output")
parser.add_option("-m", "--message",
		  default = "update",
                  help = "log message", metavar = "STRING")

(options, args) = parser.parse_args()
if len(args) != 2:
	parser.error("incorrect number of arguments")

# Read the cookies from the jar.
try:
	jar = pickle.load(file(os.path.expanduser('~/.wikicookiejar')))
except:
	print "You need to login first."
        sys.exit(1)

page = jar[0] + '/index.php?title=' + urllib.quote(args[0])

# Get wpEdittime.
url = page + '&action=edit'
req = urllib2.Request(url)

# Do the GET.
res = urllib2.urlopen(req)

wpEdittime = ''
for line in res.readlines():
	m = re.match('.*value=\"(\d+)\" name=\"wpEdittime\".*', line)
	if m:
		wpEdittime = m.group(1)
		break

# Do the edit.
url = page + '&action=submit'
req = urllib2.Request(url)

# HTTP POST arguments.
params = {
	'wpTextbox1': file(args[1]).read(),
	'wpSummary': options.message,
	'wpSave': 'Save page',
	'wpSection': '',
	'wpEdittime': wpEdittime
}

params = urllib.urlencode(params)

req.add_data(params)

# HTTP POST cookies.
for [k, v] in jar[1:len(jar)]:
		req.add_header("Cookie", k + '=' + v)

# Do the POST.
res = urllib2.urlopen(req)

# Print response to stdout.
if options.debug:
	print res.read()

